\ A molecular weight calculator V1.01 - by John Kennan
\ Last Modified on 3/8/91

\ First we include some words I wrote that I found useful
\ It assumes you keep your Include files in an assigned directory or
\ disk named Includes

Include Includes:Misc/IOWords.4th
Include Includes:Misc/Struct.4th

\ Anew Moleweight \ Don't need in Turnkey
\ *************************

CStruct NewWindow MWWindow	\ Allot a NewWindow Structure
    5 w,	 10 w,	\ Leftedge TopEdge
  300 w,	120 w,	\ Width Height
    0 c,	  1 c,	\ DetailPen BlockPen
 GadgetUp fCloseWindow | RefreshWindow |
 		     ,	\ IDCMPFlags
 Smart_Refresh WindowDrag | WindowClose | WindowSizing | WindowDepth |
 Activate |	     ,	\ Flags
    0  ,	  0  ,	\ FirstGadget Checkmark
    0  ,	  0  ,	\ Title Screen
    0  ,		\ Bitmap
  175 w,	150 w,	\ minWidth minHeight
  320 w,	150 w,	\ maxWidth maxHeight
  WbenchScreen    w,	\ Type
StructEnd

\ These are the gadget ID's.  These are the numbers Intuition
\ will return to let the program know which gadget was activated
 
25 Constant StringGadID
26 Constant QuitGadID
27 Constant InfoGadID
\ other constants

2 Constant #SRGadText	\ The number of boolean gadgets ( Info, Quit )
80 CONSTANT SRMaxChar	\ The maximum # of chars in string gadget

\ Variables

\ ******************
\ AutoRequest Code
\ Create the Autorequest for Credits

CREATE ARTextArray
0," Okay"
0," Okay"
0," In Multi-Forth by J. Kennan"

3  CONSTANT #ReqIntuitext
275 CONSTANT ARWidth
75  CONSTANT ARHEIGHT

\ An array to store Requester Intuitext Structs
#ReqIntuitext Intuitext 1Array ReqIntuitext 

: InitIText   \ Initialize intuitext
	#ReqIntuitext  0 DO
	i ReqIntuitext
	0 OVER +itFrontpen	C!
	1 OVER +itBackPen	C!
    Jam2  OVER +itDrawMode	C!
	6 OVER +itLeftEdge	W!
	4 OVER +itTopEdge	W!
	0 OVER +itITextFont	!
	0 OVER +itIText		!    \ ptr to string - initialize at run time
	0 SWAP +itNextText	!    \ ptr to next intuitext - init. at run time
  LOOP ;

InitItext Forget InitItext	\ Initialize Requester Intuitexts
				\ and then forget the intialization code
	
: RIntuitext>Text   \ put the text ptrs into intuitext at run time
		    \ Must be called before DoAutoRequest is used
	#ReqIntuitext  ARTextArray 0 ReqIntuitext Intuitext>Text ;

: DoAutoRequest ( txt--flag )  \ given a ptr to text, creates the Autorequest
	CurrentWindow @
	Swap
	0 ReqIntuitext		\ Get text for left bool gadget
	1 ReqIntuitext		\ Get text for right bool gadget
	0
	0
	ARWidth			\ Width of AutoReq.
	ARHeight		\ Height of AutoReq.
	AutoRequest ;		\ Do it!
	
: ReqInfo  ( --flag )  \ This is the autorequester for info
	2 ReqIntuitext DoAutoRequest Drop ; 

\ End of Code for AutoRequest 
\ ******************

\ The structures that will be required

#SRGadText Intuitext 1ARRAY SRGadgetIntuitexts  \ one intuitext struct
					        \ used by Bool gadget
Struct Gadget     SRStringGadget        \ string gadget
Struct StringInfo SRStringInfo 	        \ stringInfo Structure
Struct Border     SRStringBorder1	\ border for string gadget
Struct Border     SRStringBorder2       \ shadow of border for string gadget
Struct Intuitext  SRStringIntuitext	\ intuitext for input string
Struct Gadget     SRQuitGadget 	  	\ bool gadget
Struct Gadget	  SRInfoGadget		\ bool gadget
Struct Border     SRBoolBorder1		\ border for bool gadget
Struct Border     SRBoolBorder2         \ shadow of border for bool gadget

\ The text for the two Boolean gadgets
Create SRGadgetTexts   
0," Quit"
0," Info"

: InitSRGadgetIntuitexts   \ initialize the intuitext structures for the
			   \ Gadgets ( Info and Quit )
   #SRGadText 0 DO
	i SRGadgetIntuitexts
	1 OVER +itFrontPen  C!
	0 OVER +itBackPen   C!
     Jam2 OVER +itDrawMode  C!
        8 OVER +itLeftEdge  W!
        4 OVER +itTopEdge   W!
	0 OVER +itITextFont  !
	0 OVER +itIText      !  \ Init at RT
	0 SWAP +itNextText   !  \ Init at RT
    LOOP ;

InitSRGadgetIntuitexts Forget InitSRGadgetIntuitexts
				\ Initial Gadget Intuitexts at compile time
				\ then forget the initialization code

: SRGadgetIntuitexts>SRTexts    \ text addr into intuitext struct at RT
	#SRGadText SRGadgetTexts 0 SRGadgetIntuitexts Intuitext>Text ;

\ fill the string gadget structure
SRStringGadget
	  0 OVER +ggNextGadget	   !  \ Init at RT
	 20 OVER +ggLeftEdge	  W!
	 35 OVER +ggTopEdge 	  W!
	188 OVER +ggWidth	  W!
	  8 OVER +ggHeight	  W!
  gadgHcomp OVER +ggFlags	  W!
  relverify OVER +ggActivation	  W!  
   strGadget 
	    OVER +ggGadgetType    W!
	  0 OVER +ggGadgetRender   !  \ Init at RT
	  0 OVER +ggSelectRender   !
	  0 OVER +ggGadgetText	   !  \ Init at RT
	  0 OVER +ggMutualExclude  !
	  0 OVER +ggSpecialInfo	   !  \ Init at RT
StringGadID OVER +ggGadgetID	  W!
	  0 SWAP +ggUserData	   ! 
StructEnd

CREATE SRStringbdXY1   \ relative XY coord. of box around string gadget
   0 w, 11 w,  0 w, 0 w,  192 w, 0 w,

CREATE SRStringbdXY2
   192 w, 0 w, 192 w, 11 w, 0 w, 11 w,

CREATE |SRString SRMaxChar 1+ ALLOT   \ create the buffer for the string
|SRString SRMaxChar 1+ ERASE	      \ gadget text
0 |SRString C!			      \ must be initialized with empty
				      \ string

SRStringInfo StringInfo ERASE	      \ clear stringInfo struct
SRMaxChar SRStringInfo +siMaxChars W! \ set the maximum #Chars in Buffer

\ Fill String Border structure 
SRStringBorder1
   -3      OVER    +bdLeftEdge  w!
   -2      OVER    +bdTopEdge   w!
   1       OVER    +bdFrontPen  C!
   0       OVER    +bdBackPen   C!
   jam1    OVER    +bdDrawMode  C!
   3       OVER    +bdCount     C!
   0       OVER    +bdXY         !  \ Init at RT
   0       SWAP    +bdNextBorder !  \ Init at RT
Structend

SRStringBorder2
   -3      OVER    +bdLeftEdge  w!
   -2      OVER    +bdTopEdge   w!
   2       OVER    +bdFrontPen  C!
   0       OVER    +bdBackPen   C!
   jam1    OVER    +bdDrawMode  C!
   3       OVER    +bdCount     C!
   0       OVER    +bdXY         !  \ Init at RT
   0       SWAP    +bdNextBorder !  \ Init at RT
Structend

: InitStrGadget     \ Run time initializations of String Gadget Pointers
	SRStringbdXY1 SRStringBorder1 +bdXY !
				\ give border ptr to image
	SRStringbdXY2 SRStringBorder2 +bdXY !
				\ give shadow border ptr to image
	SRStringBorder2 SRStringBorder1 +bdNextBorder !
				\ link the two borders for the string gad.
	SRStringBorder1 SRStringGadget +ggGadgetRender !
				\ give gadget ptr to border 
	|SRString SRStringInfo +siBuffer ! 
				\ give Gadget's Info ptr to str buffer
	SRStringInfo SRStringGadget +ggSpecialInfo ! ;
				\ give Gadget ptr to Info struct


SRQuitGadget		\ fill the Quit gadget
	  0 OVER +ggNextGadget	   !  \ Init at RT
        125 OVER +ggLeftEdge	  W!
	 70 OVER +ggTopEdge	  W!
	 61 OVER +ggWidth	  W!
	 18 OVER +ggHeight	  W!
  gadgHcomp OVER +ggFlags	  W!
  relVerify 		        
	    OVER +ggActivation	  W!  \ gadget will end requester
  boolGadget 
	    OVER +ggGadgetType    W!
	  0 OVER +ggGadgetRender   !  \ Init at RT
	  0 OVER +ggSelectRender   !
	  0 OVER +ggGadgetText	   !  \ Init at RT
	  0 OVER +ggMutualExclude  !
	  0 OVER +ggSpecialInfo	   !
  QuitGadID OVER +ggGadgetID	  W!	
	  0 SWAP +ggUserData	   !      
Structend

SRQuitGadget SRInfoGadget Gadget CMove	\ Copy the Quit Gadget Structure

SRInfoGadget				\ Then make minor changes
         40 OVER +ggLeftEdge	  W!
  InfoGadID Swap +ggGadgetID	  W!

CREATE SRBoolbdXY1   \ 3 XY pairs describing inner box around Bool gadgets
    0 w, 18 w,
    0 w,  0 w,
   62 w,  0 w,

CREATE SRBoolbdXY2   \ 3 XY pairs describing shadow for box around Bool gadgets
   63 w,  0 w,
   63 w, 19 w,
    0 w, 19 w,

SRBoolBorder1   \ fill border structure for bool gadgets
   -2      OVER    +bdLeftEdge  w!
   -1      OVER    +bdTopEdge   w!
   1       OVER    +bdFrontPen  C!
   0       OVER    +bdBackPen   C!
   jam1    OVER    +bdDrawMode  C!
   3       OVER    +bdCount     C!
   0       OVER    +bdXY         !  \ init at RT
   0       SWAP    +bdNextBorder !  \ init at RT
Structend

SRBoolBorder2   \ border structure for shadow for bool gadgets
   -2      OVER    +bdLeftEdge  w!
   -1      OVER    +bdTopEdge   w!
   2       OVER    +bdFrontPen  C!
   0       OVER    +bdBackPen   C!
   jam1    OVER    +bdDrawMode  C!
   3       OVER    +bdCount     C!
   0       OVER    +bdXY         !  \ init at RT
   0       SWAP    +bdNextBorder !  \ init at RT
Structend

: SRBoolGadget>Border  \ run time linkage of gadget with border
	SRBoolbdXY1    SRBoolBorder1   +bdXY !
	SRBoolbdXY2    SRBoolBorder2   +bdXY !
	SRBoolBorder2  SRBoolBorder1   +bdNextBorder !
	SRBoolBorder1  SRQuitGadget +ggGadgetRender !
	SRBoolBorder1  SRInfoGadget +ggGadgetRender ! ;

: SRBoolGadget>Text \ run time linkage of gadget with text
	0 SRGadgetIntuitexts SRQuitGadget +ggGadgetText !
	1 SRGadgetIntuitexts SRInfoGadget +ggGadgetText ! ;
	
: SRStrGadget>SRBoolGadgets \ run time linkage of 
			    \ Bool gadgets to string gadget
   SRQuitGadget  SRStringGadget +ggNextGadget !
   SRInfoGadget  SRQuitGadget   +ggNextGadget !  ;
	
\ Fill the string intuitext by copying a previously defined
\ Intuitext structure

0 SRGadgetIntuitexts SRStringIntuitext INTUITEXT CMOVE
        SRStringIntuitext   
        0 OVER +itLeftEdge  W!
      -10 Swap +itTopEdge   W!

: Intuitext>SRString ( -- )   \ Run time linkage of Intuitext with text
	0" Molecular Formula:" SRStringIntuitext +itIText ! ;

: SRGadget>SRIntuitext ( -- )  \ Run time linkage of Gadget with intuitext
	SRStringIntuitext SRStringGadget +ggGadgetText ! ;
	
: Window>Data ( -- )  \ runtime linkage of file requester
    MWWindow
    0" MoleWt Calc."  Over +nwTitle !
    SRStringGadget    Swap +nwFirstGadget !  ; \ give window a ptr to gadgets

: CorrectRunTimePtrs ( -- )	
	InitStrGadget
	RIntuitext>Text		\ Give Req. Intuitexts ptrs to text
        SRGadgetIntuitexts>SRTexts
	SRStrGadget>SRBoolGadgets
	SRBoolGadget>Border
	SRBoolGadget>Text
	Window>Data
	Intuitext>SRString
	SRGadget>SRIntuitext ;

CREATE MoleWtTable
1008 ,		4003 ,		6941 ,		9012 ,
10810 ,		12011 ,		14007 ,		15999 ,
18998 ,		20179 ,		22990 ,		24305 ,
26982 ,		28086 ,		30974 ,		32060 ,
35453 ,		39948 ,		39102 ,		40080 ,
44956 ,		47900 ,		50941 ,		51996 ,
54938 ,		55847 ,		58933 ,		58710 ,
63546 ,		65370 ,		69720 ,		72590 ,
74922 ,		78960 ,		79904 ,		83800 ,
85468 ,		87620 ,		88906 ,		91220 ,
92906 ,		95940 ,		98906 ,		101070 ,
102906 ,	106400 ,	107868 ,	112400 ,
114820 ,	118690 ,	121750 ,	127600 ,
126905 ,	131300 ,	132906 ,	137340 ,
138906 ,	178490 ,	180948 ,	183850 ,
186200 ,	190200 ,	192220 ,	195090 ,
196967 ,	200590 ,	204370 ,	207200 ,
208981 ,	210000 ,	210000 ,	222000 ,
223000 ,	226025 ,	227000 ,	140120 ,
140908 ,	144240 ,	147000 ,	150400 ,
151960 ,	157250 ,	158925 ,	162500 ,
164930 ,	167260 ,	168934 ,	173040 ,
174970 ,	232038 ,	231036 ,	238029 ,
237048 ,	242000 ,	243000 ,	247000 ,
247000 ,	251000 ,	254000 ,	253000 ,
256000 ,	254000 ,	257000 ,
\ a few extras for shortcuts - Me=CH3, Et=CH3CH2, Vi=CH2CH, Ph=C6H5
15035 ,		29062 ,		27046 ,		77106 ,

CREATE El$
," H HeLiBeB C N O F NeNaMgAlSiP S ClArK CaScTiV CrMnFeCoNiCuZnGaGeAsSeBrKrRbSrY ZrNbMoTcRuRhPdAgCdInSnSbTeI XeCsBaLaHfTaW ReOsIrPtAuHgTlPbBiPoAtRnFrRaAcCePrNdPmSmEuGdTbDyHoErTmYbLuThPaU NpPuAmCmBkCfEsFmMdNoLrMeEtViPh"

CREATE |StrBuf  10 ALLOT	\ A buffer for parsing the string

: NMatch ( addr$\$cnt\addr\cnt -- [#instring] or [0] )  \ find str at addr$
   LOCALS| LStr AStr LStr2 AStr2 |                     \ in str at addr
   LStr  LStr2 -	\ set up to match from start 
			\ to LStr chars from end of Str1
   0 TO  LStr     	\ Now use LStr to count our position in the string Str1
   0 DO 
     AStr2 LStr2  AStr I + -TEXT    \ Loop through and check for match
     NOT IF
       I 1+ TO LStr	\ If found, set LStr to the char cnt.
     THEN
   LOOP LStr ; 

: fdInString  ( -- [#instr] or [0] )  \ look for valid element in El$
   |StrBuf 1+ 2			\ pointer to string buffer and
				\ length of single elemment ( 2 chars)
   El$ DUP 1+ SWAP C@ 1+	\ pointer to string holding all element names
				\ and the length
   NMATCH ;			\ look for match	

VARIABLE >Formula	\ ptr to next char to parse
VARIABLE >StrBuf	\ a temporary buffer to parse strings in
VARIABLE >EndFormula	\ ptr to the end of the string
VARIABLE ErrorFlag
VARIABLE ParenCnt   \ counts the number of unresolved parentheses
0 ErrorFlag !

: InitPtr ( -- )             \ Initialize pointers for string transfer
   |SRString >Formula !		\ Init. to beginning of String Gad. buffer
   |StrBuf 1+ >StrBuf !		\ Init. to beginning of temp. str. buffer
   |SRString DUP 0$Len + >EndFormula ! ;  \ init. ptr. to end of formula

: GetNextChar ( --char )	\ Get the next character in the formula
	>Formula @ C@ ;

: AdvancePtr ( -- )		\ Increment pointer in formula to next Char
	1 >Formula +! ;

: ResetBuf     ( -- )  \ fills strbuf with spaces and sets str length to 2
   |StrBuf 2 OVER C!   \ set string length to 2 characters
   1+ DUP 9 + SWAP DO 32 I C! LOOP  \ fill the rest of the buffer with blanks
   |StrBuf 1+ >StrBuf !  ; \ set pointer to first char in (now empty) buffer

:  AtomWt@   ( #inStr -- Molewt )	\ Get the Atomic Wt. out of the table
   1+ 2/ 1- 4* MoleWtTable + @ ;

: TestCap ( -- )		\ test if letter pointed to by >Formula is
   >Formula @ C@ 65 90 RANGE	\ a capital letter
   If >StrBuf @ C! Else		\ if so move to buffer
   1 ErrorFlag !		\ otherwise set errorflag - invalid formula
   THEN				\ Increment pointers 
   1 DUP >Formula +! >StrBuf +! ;
 
: TestLow ( -- )		\ Test if letter pointed to by >Formula is
   >Formula @ C@ 97 122 RANGE  	\ lower case letter
   IF >StrBuf @ C!		\ if so move to buffer
   1 >Formula +!		\ and increment pointer & remove from stack
   ELSE DROP THEN ;		\ or remove non lower case from stack

: NumCheck       ( n--flag )	\ check if n is an ASCII number
   48 57 RANGE SWAP DROP ;

: TestNum ( --)                 \ If the string at the current >Formula
   >Formula @			\ is a numeric string, then evaluate
   LOCALS| EndNum |             \ and multiply top of stack by that amount
   BEGIN EndNum C@ NumCheck While
   EndNum 1+ TO EndNum REPEAT
   EndNum >Formula @ - DUP
   IF DUP >Formula @ SWAP $>NUMBER DROP
   SWAP >Formula +! * ELSE DROP THEN ;

: NotDone?  ( -- flag)   \ flag=-1 if not done
   ErrorFlag @  IF 0 ELSE >Formula @ >EndFormula @ - 0< THEN ;

: OpenParen ( -- 0 )
	  1 >Formula +!		\ Increment ptr to next char in formula
	  1 ParenCnt +!		\ Increment the parenthesis count
	  0 ;  			\ start a new subgroup on top of stack

: CloseParen
	ParenCnt @ 0 > IF	\	Make sure Parentheses match
	  1 >Formula +! -1 ParenCnt +!  \ advance ptr and dec. ParenCnt
	  NotDone? IF TestNum THEN	
	  + 				\ total Molecular wt.
	ELSE  1 ERRORFLAG ! THEN ; 	\ If parenCnt doesn't match then error

: GetEl ( -- )	\ get the next element in the string
	ResetBuf
	GetNextChar  >StrBuf @ C!	 \ move char to scratchpad
	1 DUP >Formula +! >StrBuf +! \ advance ptrs
	NotDone?    
	IF TestLow THEN              \ then check next char for lower case
	FdinString DUP               \ find occurence of string in EL$
	NOT IF 1  ErrorFlag ! THEN
	AtomWt@                \ put molecular wt. on stack
	NotDone?
	IF TestNum THEN              \ check for number
	+ ;                          \ sum molecular wt.

: DisplayDecimal ( n-- )   \ prints as decimal to three places
   RPort SWAP			\ ( RPort\n - )
   DUP ABS			\ ( RPort\n\abs(n)-- )
   <# # # # ASCII . HOLD #S SWAP SIGN #>	\ ( RPort\>Text\Cnt-- )
   RPort 120 60 Move
   RPort ClearEOL	\ Move to Position and Clear line
   RPort 120 60 Move
   Text Drop
   CurrentWindow @ RefreshWindowFrame ;

: NDROP ( n -- )  \ drops n and the following n numbers off the stack
	?DUP IF 0 DO DROP LOOP THEN ;
	
: PrintMoleWt
   0 	\ Initialize Molecular Weight on stack
   InitPtr
   0 ParenCnt !	\ intialize variable to count parenthesis
   BEGIN NotDone? WHILE 
	GetNextChar
	CASE
	   40  OF OpenParen ENDOF	\ Open parentheses encountered
	   41  OF CloseParen ENDOF	\ Closed parentheses encountered
	   65  90  RANGE.OF  GetEl  ENDOF \ Probably an element encountered
	   1 ErrorFlag !	\ if none of the above, then set error flag
	ENDCASE
   REPEAT	
   ErrorFlag @ ParenCnt @ OR NOT IF	\ Check for errors or unmatched paren.
     Displaydecimal			\ Display the molecular Weight
   ELSE Depth NDROP
     RPort 120 60 Move
     RPort ClearEOL			\ Clear old text
     RPort 120 60  Move
     RPort 0" Invalid Input" DUP 0$Len Text DROP
     CurrentWindow @ RefreshWindowFrame
     0 ErrorFlag !
   THEN ;

: SRGadEvent ( --gadID )  \ identifies the Gadget that was activated
   ThisEvent  +eIaddress @
	      +ggGadgetID W@ ;

: CheckGadEvent
	SRGadEvent	\ Find out which Gadget was activated
	CASE
	   StringGadID    OF PrintMoleWt 0  EndOf \ User input Formula
	   InfoGadID	  OF ReqInfo     0  EndOF
	   QuitGadID      OF 1              EndOf \ User hit Quit Gadget
			\ Quit leaves a 1 thus ending the loop
	   0            \ If something else happened, ignore it
	EndCase ;
  
: PrintWindowText ( -- ) \ Put text in window at start or during window resize
    RPort 20 20 Move			\ locate pen for text
    RPort 0" Molecular Weight Calculator" DUP 0$Len Text DROP
    RPort 10 60 Move
    RPort 0" Molecular Wt: " Dup 0$Len Text DROP ;

: RefreshCurrentWindow
    CurrentWindow @ BeginRefresh
    PrintWindowText
    CurrentWindow @ True EndRefresh ;

: WaitForEvents (  -- ) 
	Begin
	  SRStringGadget CurrentWindow @ 0	\ Setup Intuition ActiveGad.
	  ActivateGadget Drop			\ Activate String Gadget
	  WaitEvent             		\ Wait for user to respond
	  CASE
	     RefreshWindow OF RefreshCurrentWindow 0 Endof \ Refresh window text
	     GadgetUP  OF  CheckGadEvent  EndOF            \ A gadget was used
	     fCloseWindow OF 1 Endof		           \ User closed window
	     0
	  EndCase
	Until ;

: Program  ( -- )
   CorrectRunTimePtrs	\ Runtime linkage of ptrs.
   MWWindow OpenWindow  \ Open the Window
   CurrentWindow @ 0= IF Bye Then  \ If window doesn't open abort
   PrintWindowText
   WaitForEvents			\ Go into main program loop
   CurrentWindow @ CloseWindow		\ Cleanup
   ?Turnkey IF Bye Then ;
